package cn.ibizlab.humanresource.core.humanresource.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.humanresource.core.humanresource.domain.HRCertificate;
import cn.ibizlab.humanresource.core.humanresource.filter.HRCertificateSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[HRCertificate] 服务对象接口
 */
public interface IHRCertificateService extends IService<HRCertificate>{

    boolean create(HRCertificate et) ;
    void createBatch(List<HRCertificate> list) ;
    boolean update(HRCertificate et) ;
    void updateBatch(List<HRCertificate> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    HRCertificate get(String key) ;
    HRCertificate getDraft(HRCertificate et) ;
    boolean checkKey(HRCertificate et) ;
    boolean save(HRCertificate et) ;
    void saveBatch(List<HRCertificate> list) ;
    Page<HRCertificate> searchActive(HRCertificateSearchContext context) ;
    Page<HRCertificate> searchDefault(HRCertificateSearchContext context) ;
    Page<HRCertificate> searchInActive(HRCertificateSearchContext context) ;
    Page<HRCertificate> searchSoonExpired(HRCertificateSearchContext context) ;
    List<HRCertificate> selectByHremployeeid(String employeeid) ;
    void removeByHremployeeid(String employeeid) ;
    List<HRCertificate> selectByRegisterorganizationid(String organizationid) ;
    void removeByRegisterorganizationid(String organizationid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<HRCertificate> getHrcertificateByIds(List<String> ids) ;
    List<HRCertificate> getHrcertificateByEntities(List<HRCertificate> entities) ;
}


